#ifndef Fenster_H
#define Fenster_H

#include "Zeichnung.h"

namespace Framework
{
	class VScrollBar; // Scroll.h
	class HScrollBar; // Scroll.h
	class TextFeld; // TextFeld.h
	class LRahmen; // Rahmen.h
	class Bildschirm; // Bildschirm.h
	class AlphaFeld; // AlphaFeld.h
	class Schrift; // Schrift.h
	class Text; // Text.h
	class Bild; // Bild.h
	class WFenster; // aus dieser Datei
	class WFensterArray; // aus dieser Datei
	class Fenster; // aus dieser Datei

	// Erzeugen einer normalen Fensterklasse
	__declspec( dllexport ) WNDCLASS F_Normal( HINSTANCE hInst );
	__declspec( dllexport ) WNDCLASSEX F_NormalEx( HINSTANCE hInst );

	__declspec( dllexport ) LRESULT CALLBACK WindowProc( HWND hwnd, UINT message, WPARAM wparam, LPARAM lparam );
	__declspec( dllexport ) void StartNachrichtenSchleife();
	__declspec( dllexport ) void StopNachrichtenSchleife( HWND hwnd );

	__declspec( dllexport ) unsigned char VirtualZuChar( int Virtual );
	// Klasse fr ein Fenster in Windows
	class WFenster
	{
	private:
		HWND hWnd; // Handel zum Fenster
		int style;
		void *makParam;
		void *sakParam;
		void *takParam;
		bool( *MausAktion )( void *, void *, MausEreignis );
		void( *VSchlieAktion )( void *, void * );
		void( *NSchlieAktion )( void *, void * );
		bool( *TastaturAktion )( void *, void *, TastaturEreignis );
		Bildschirm *screen;
		int mx, my;
		bool verschiebbar;
		int ref;
		HWND rahmen;
		HBITMAP bitmap;
		HDC hdc;

	public:
		//--Konstruktor--
		__declspec( dllexport ) WFenster();
		__declspec( dllexport ) WFenster( HWND hWnd );
		//--Destruktor--
		__declspec( dllexport ) ~WFenster();
		// nicht constant
		__declspec( dllexport ) void erstellen( int style, WNDCLASS wc ); // Das Fenster Erstellen
		__declspec( dllexport ) void erstellenEx( int exStyle, int style, WNDCLASSEX wc ); // Das Fenster Erstellen
		__declspec( dllexport ) void setAnzeigeModus( int mod ); // Zeigt das Fenster im bergebenen Modus an
		__declspec( dllexport ) bool setFokus(); // Setzt den Fokus auf das Fenster
		__declspec( dllexport ) void setPosition( Punkt &pos ); // Bildschirmposition des Fensters setzen
		__declspec( dllexport ) void setGre( Punkt &gre ); // Die gre des Fensters setzen
		__declspec( dllexport ) void setGre( int breite, int hhe );
		__declspec( dllexport ) void setBounds( Punkt &pos, Punkt &gre ); // Gre und Porition in einem
		__declspec( dllexport ) void setBildschirm( Bildschirm *screen );
		__declspec( dllexport ) void zerstren(); // Zerstrt das Fenster
		__declspec( dllexport ) void doMausAktion( MausEreignis &me ); // ruft MausAktion auf
		__declspec( dllexport ) void doVSchlieAktion(); // ruft VSchlieAktion auf
		__declspec( dllexport ) void doNSchlieAktion(); // ruft NSchlieAktion auf
		__declspec( dllexport ) void doTastaturAktion( TastaturEreignis &et ); // ruft TastaturAktion auf
		__declspec( dllexport ) void doRestoreMessage(); // macht den Rahmen sichtbar
		__declspec( dllexport ) void setMausEreignisParameter( void *p ); // setzt den Parameter vom Maus Ereignis
		__declspec( dllexport ) void setSchlieEreignisParameter( void *p ); // setzt den Parameter vom Schlie Ereignis
		__declspec( dllexport ) void setTastaturEreignisParameter( void *p ); // setzt den Parameter vom Tastatur Ereignis
		__declspec( dllexport ) void setMausAktion( bool( *MausAk )( void *, void *, MausEreignis ) ); // setzt das MausEreignis
		__declspec( dllexport ) void setVSchlieAktion( void( *vSchlieAk )( void *, void * ) ); // setzt v schlie Aktion
		__declspec( dllexport ) void setNSchlieAktion( void( *nSchlieAk )( void *, void * ) ); // setzt n schlie Aktion
		__declspec( dllexport ) void setTastaturAktion( bool( *TastaturAk )( void *, void *, TastaturEreignis ) ); // setzt das TastaturEreignis
		__declspec( dllexport ) void setFensterHandle( HWND hWnd ); // setzt das operationsfenster
		__declspec( dllexport ) void setVerschiebbar( bool verschiebbar ); // legt fest, ob das Fenster durch ziehen mit Maus verschoben werden kann
		__declspec( dllexport ) void ladeRahmenFenster( Bild *zBild, HINSTANCE hinst ); // setzt einen Transpatenten Rahmen um das Fenster
		// constant
		__declspec( dllexport ) HWND getFensterHandle() const; // gibt das Fenster Handle zurck
		__declspec( dllexport ) Punkt getPosition() const; // gibt die Fensterposition zurck
		__declspec( dllexport ) Punkt getKrperPosition() const; // gibt die Fenster Krperposition zurck
		__declspec( dllexport ) Punkt getGre() const; // gibt die Fenstergre zurck
		__declspec( dllexport ) Punkt getKrperGre() const; // gibt die Fenster Krpergre zurck
		__declspec( dllexport ) int getKrperBreite() const; // gibt die Fenster Krperbreite zurck
		__declspec( dllexport ) int getKrperHhe() const; // gibt die Fenster Krperhhe zurck
		__declspec( dllexport ) bool hatMausAktion() const; // Prft, ob eine Aktion bei MausEreignis festgelegt wurde
		__declspec( dllexport ) bool hatVSchlieAktion() const; // Prft, ob eine Aktion vor Fensterschlieen festgelegt wurde
		__declspec( dllexport ) bool hatNSchlieAktion() const; // Prft, ob eine Aktion nach Fensterschlieen festgelegt wurde
		__declspec( dllexport ) bool hatTastaturAktion() const; // Prft, ob eine Aktion bei TastaturEreignis festgelegt wurde
		__declspec( dllexport ) Bildschirm *getBildschirm() const;
		__declspec( dllexport ) Bildschirm *zBildschirm() const;
		__declspec( dllexport ) bool istVerschiebbar() const; // prft, ob das Fenster durch ziehen mit Maus verschoben werden kann
		// Reference Counting
		__declspec( dllexport ) WFenster *getThis();
		__declspec( dllexport ) WFenster *release();
	};

	// Verwaltung der WFenster im Framework
	class WFensterArray
	{
	private:
		WFensterArray *next;
		WFenster *This;

	public:
		// Konstruktor 
		__declspec( dllexport ) WFensterArray();
		// Destruktor 
		__declspec( dllexport ) ~WFensterArray();
		// add und remove 
		__declspec( dllexport ) bool addFenster( WFenster *fenster );
		__declspec( dllexport ) bool removeFenster( WFenster *fenster );
		__declspec( dllexport ) WFensterArray* getNext();
		__declspec( dllexport ) void setNext0();
		__declspec( dllexport ) void del();
		// Messages 
		__declspec( dllexport ) bool sendVSchlieMessage( HWND hWnd );
		__declspec( dllexport ) bool sendNSchlieMessage( HWND hwnd );
		__declspec( dllexport ) bool sendMausMessage( HWND hWnd, MausEreignis &me );
		__declspec( dllexport ) bool sendTastaturMessage( HWND hwnd, TastaturEreignis &te );
		__declspec( dllexport ) bool sendRestoreMessage( HWND hwnd );
		__declspec( dllexport ) WFenster *getThis();
	};

	// WMessageBox
	__declspec( dllexport ) void WMessageBox( HWND hWnd, Text *titel, Text *meldung, UINT style );

	// Fenster Klasse im Programm
	class Fenster : public Zeichnung
	{
    public:
        class Style : public Zeichnung::Style
        {
        public:
            const static __int64 KrperHintergrund = 0x000000008;
            const static __int64 KrperHAlpha = 0x000000010;
            const static __int64 KrperHBild = 0x000000020;
            const static __int64 KrperBuffered = 0x000000040;
            const static __int64 Titel = 0x000000080;
            const static __int64 TitelHintergrund = 0x000000100;
            const static __int64 TitelHAlpha = 0x000000200;
            const static __int64 TitelHBild = 0x000000400;
            const static __int64 TitelBuffered = 0x000000800;
            const static __int64 Schliebar = 0x000001000;
            const static __int64 SchlieHintergrund = 0x000002000;
            const static __int64 SchlieHAlpha = 0x000004000;
            const static __int64 SchlieHBild = 0x000008000;
            const static __int64 SchlieBuffer = 0x000010000;
            const static __int64 SchlieKlickBuffer = 0x000020000;
            const static __int64 Beweglich = 0x000040000;
            const static __int64 Breitenderbar = 0x000080000;
            const static __int64 Hhenderbar = 0x000100000;
            const static __int64 TitelHhenderbar = 0x000200000;
            const static __int64 MinBr = 0x000400000;
            const static __int64 MaxBr = 0x000800000;
            const static __int64 MinH = 0x001000000;
            const static __int64 MaxH = 0x002000000;
            const static __int64 Krper_minBr = 0x004000000;
            const static __int64 Krper_maxBr = 0x008000000;
            const static __int64 Krper_minH = 0x010000000;
            const static __int64 Krper_maxH = 0x020000000;
            const static __int64 VScroll = 0x040000000;
            const static __int64 HScroll = 0x080000000;
            const static __int64 METransparenz = 0x100000000;
            const static __int64 Rahmen = 0x200000000;

            const static __int64 min_max = MinH | MaxH | MaxBr | MaxH;
            const static __int64 krper_min_max = Krper_minBr | Krper_maxBr | Krper_minH | Krper_maxBr;
            const static __int64 scroll = VScroll | HScroll;
            const static __int64 nichtfixiert = TitelHhenderbar | Hhenderbar | Breitenderbar | Beweglich;

            const static __int64 normal = Sichtbar | Erlaubt | Rahmen | Titel | TitelBuffered | Schliebar | SchlieHBild | SchlieKlickBuffer | Beweglich;
        };
	private:
		bool( *schlieenMe )( void *, void *, MausEreignis );
		void *schlieenMeParam;
		LRahmen *rahmen;
		TextFeld *titel;
		ZeichnungArray *members;
		int bgKrperFarbe;
		Bild *bgKrperBild;
		AlphaFeld *krperBuffer;
		int bgSchlieFarbe;
		Bild *bgSchlieBild;
		AlphaFeld *schlieBuffer;
		AlphaFeld *schlieKlickBuffer;
		VScrollBar *vScroll;
		HScrollBar *hScroll;
		Punkt min, max;
		Punkt kMin, kMax;
		bool schlieKlick, klick;
		int mx, my;
		int ref;

	public:
		// Konstruktor 
		__declspec( dllexport ) Fenster();
		// Destruktor 
		__declspec( dllexport ) ~Fenster();
		// nicht const 
		// -- Rahmen -- 
		__declspec( dllexport ) void setRahmenZ( LRahmen *ram ); // setzt den rahmen
		__declspec( dllexport ) void setRFarbe( int f ); // setzt die Rahmen Farbe
		__declspec( dllexport ) void setRBreite( int br ); // setzt die Breite des Rahmens
		// -- Titel -- 
		__declspec( dllexport ) void setTitel( Text *txt ); // setzt den Titel
		__declspec( dllexport ) void setTitelZ( Text *txt );
		__declspec( dllexport ) void setTitel( const char *txt );
		__declspec( dllexport ) void setTTextFeldZ( TextFeld *tf ); // setzt das Titel TextFeld
		// -- Schrift -- 
		__declspec( dllexport ) void setTSchriftZ( Schrift *schrift ); // setzt die Titel Schrift
		__declspec( dllexport ) void setTSFarbe( int f ); // setzt die Titel Schrift Farbe
		__declspec( dllexport ) void setTSGre( int gr ); // setzt die Titel Schrift Gre
		// -- Titel Hintergrund -- 
		__declspec( dllexport ) void setTBgFarbe( int f ); // setzt Titel Hintergrund farbe
		// -- Titel AlphaFeld -- 
		__declspec( dllexport ) void setTAlphaFeldZ( AlphaFeld *af ); // setzt das Titel AlphaFeld
		__declspec( dllexport ) void setTAfFarbe( int f ); // setzt die Titel AlphFeld Farbe
		__declspec( dllexport ) void setTAfStrke( int st ); // setzt die Strke des Titel AlphaFeldes
		// -- Titel Hintergrund Bild -- 
		__declspec( dllexport ) void setTBgBild( Bild *b ); // setzt das Titel Hintergrund Bild
		__declspec( dllexport ) void setTBgBildZ( Bild *b );
		// -- Titel Rahmen -- 
		__declspec( dllexport ) void setTRahmenZ( LRahmen *ram ); // set Titel Rahmen
		__declspec( dllexport ) void setTRFarbe( int f ); // setzt die Titel Rahmen Farbe
		__declspec( dllexport ) void setTRBreite( int br ); // setzt die Titel Rahmen Breite
		// -- Krper Hintergrund -- 
		__declspec( dllexport ) void setKBgFarbe( int f ); // setzt die Krper Hintergrund Farbe
		// -- Krper Hintergrund Bild -- 
		__declspec( dllexport ) void setKBgBild( Bild *b ); // setzt das Krper Hintergrund Bild
		__declspec( dllexport ) void setKBgBildZ( Bild *b );
		// -- Krper AlphaFeld -- 
		__declspec( dllexport ) void setKAlphaFeldZ( AlphaFeld *af ); // setzt das Krper AlphaFeld
		__declspec( dllexport ) void setKAfFarbe( int f ); // setzt Krper AlphaFeld Farbe
		__declspec( dllexport ) void setKAfStrke( int st ); // setzt die Strke des Krper AlphaFeldes
		// -- Schlieen --
		__declspec( dllexport ) void setSchlieenMeParam( void *param );
		__declspec( dllexport ) void setSchlieenMe( bool( *schlieenMe )( void *, void *, MausEreignis ) ); // setzt das Schlieen Mausereignis
		// -- Schlieen Hintergrund -- 
		__declspec( dllexport ) void setSBgFarbe( int f ); // setzt die Schlie Hintergrund Farbe
		// -- Schlieen Hintergrund Bild -- 
		__declspec( dllexport ) void setSBgBild( Bild *b ); // setzt das Schlie Hintergrund Bild
		__declspec( dllexport ) void setSBgBildZ( Bild *b );
		// -- Schlieen AlphaFeld -- 
		__declspec( dllexport ) void setSAlphaFeldZ( AlphaFeld *af ); // setzt das Schlie AlphaFeld
		__declspec( dllexport ) void setSAfFarbe( int f ); // setzt die Farbe des Schlie AlphaFeldes
		__declspec( dllexport ) void setSAfStrke( int st ); // setzt die Strke des Schlie AlphaFeldes
		// -- Schlieen Klick AlphaFeld -- 
		__declspec( dllexport ) void setSKAlphaFeldZ( AlphaFeld *af ); // setzt das Schlie klick AlphaFeld
		__declspec( dllexport ) void setSKAfFarbe( int f ); // setzt die Farbe des Schlie klick AlphaFeldes
		__declspec( dllexport ) void setSKAfStrke( int st ); // setzt die Strke des Schlie klick AlphaFeldes
		// -- min max -- 
		__declspec( dllexport ) void setMin( int mx, int my ); // setzt die Mindest Fenster Gre
		__declspec( dllexport ) void setMin( const Punkt &min );
		__declspec( dllexport ) void setMax( int mx, int my ); // setzt die Maximale Fenster Gre
		__declspec( dllexport ) void setMax( const Punkt &max );
		__declspec( dllexport ) void setKMin( int mx, int my ); // setzt die Mindest Krper Gre
		__declspec( dllexport ) void setKMin( const Punkt &min );
		__declspec( dllexport ) void setKMax( int mx, int my ); // setzt die Maximale Krper Gre
		__declspec( dllexport ) void setKMax( const Punkt &max );
		// -- scroll -- 
		__declspec( dllexport ) void setHScrollBarZ( HScrollBar *hScroll ); // setzt die Horizontale Scroll Bar
		__declspec( dllexport ) void setVScrollBarZ( VScrollBar *vScroll ); // setzt die Vertikale Scroll BAr
		__declspec( dllexport ) void setHSBMax( int max ); // setzt das Scroll Maximum
		__declspec( dllexport ) void setVSBMax( int max );
		__declspec( dllexport ) void setHSBScroll( int scroll ); // setzt die momentane Scroll Position
		__declspec( dllexport ) void setVSBScroll( int scroll );
		// -- Members -- 
		__declspec( dllexport ) void addMember( Zeichnung *zOobj ); // fgt einen Member hinzu
		__declspec( dllexport ) void removeMember( Zeichnung *zObj ); // entfernt einen Member
		// -- Messages -- 
		__declspec( dllexport ) bool tick( double tickval ) override; // tick
		__declspec( dllexport ) void doMausEreignis( MausEreignis &me ) override;
		__declspec( dllexport ) void doTastaturEreignis( TastaturEreignis &te ) override;
		// -- Render -- 
		__declspec( dllexport ) void render( Bild &zRObj ) override; // zeichent nach zRObj
		// constant 
		// -- Rahmen -- 
		__declspec( dllexport ) LRahmen *getRahmen() const; // gibt den Rahmen zurck
		__declspec( dllexport ) LRahmen *zRahmen() const;
		__declspec( dllexport ) int getRFarbe() const; // gibt die Farbe des Rahmens zurck
		__declspec( dllexport ) int getRBreite() const; // gibt die breite des Rahmens zurck
		// -- Titel  -- 
		__declspec( dllexport ) Text *getTitel() const; // gibt den Titel zurck
		__declspec( dllexport ) Text *zTitel() const;
		__declspec( dllexport ) TextFeld *getTTextFeld() const; // gibt das Titel TextFeld zurck
		__declspec( dllexport ) TextFeld *zTTextFeld() const;
		// -- Titel Schrift -- 
		__declspec( dllexport ) Schrift *getTSchrift() const; // gibt die Titel Schrift zurck
		__declspec( dllexport ) Schrift *zTSchrift() const;
		__declspec( dllexport ) int getTSFarbe() const; // gibt die Titel Schrift Farbe zurck
		__declspec( dllexport ) int getTSGre() const; // gibt die Titel Schrift Gre zurck
		// -- Titel Hintergrund -- 
		__declspec( dllexport ) int getTBgFarbe() const; // gibt die Titel Hintergrund Farbe zurck
		// -- Titel AlphaFeld -- 
		__declspec( dllexport ) AlphaFeld *getTAlphaFeld() const; // gibt das Titel AlphaFeld zurck
		__declspec( dllexport ) AlphaFeld *zTAlphaFeld() const;
		__declspec( dllexport ) int getTAfFarbe() const; // gibt die Farbe des Titel AlphaFeldes zurck
		__declspec( dllexport ) int getTAfStrke() const; // gibt die Strke des TitelAlphaFeldes zurck
		// -- Titel Hintergrund Bild -- 
		__declspec( dllexport ) Bild *getTBgBild() const; // gibt das Titel Hintergrund Bild zurck
		__declspec( dllexport ) Bild *zTBgBild() const;
		// -- Titel Rahmen -- 
		__declspec( dllexport ) LRahmen *getTRahmen() const; // gibt den Titel Rahmen zurck
		__declspec( dllexport ) LRahmen *zTRahmen() const;
		__declspec( dllexport ) int getTRFarbe() const; // gibt die Farbe des Titel Rahmens zurck
		__declspec( dllexport ) int getTRBreite() const; // gibt die Breite des Titel Rahmens zurck
		// -- Krper Hintergrund -- 
		__declspec( dllexport ) int getKBgFarbe() const; // gibt die Krper Hintergrund Farbe zurck
		// -- Krper Hintergrund Bild -- 
		__declspec( dllexport ) Bild *getKBgBild() const; // gibt das Krper Hintergrund Bild zurck
		__declspec( dllexport ) Bild *zKBgBild() const;
		// -- Krper AlphaFeld -- 
		__declspec( dllexport ) AlphaFeld *getKAlphaFeld() const; // gibt das Krper AlphaFeld zurck
		__declspec( dllexport ) AlphaFeld *zKAlphaFeld() const;
		__declspec( dllexport ) int getKAfFarbe() const; // gibt die Farbe des Krper AlphaFeldes zurck
		__declspec( dllexport ) int getKAfStrke() const; // gibt die Strke des Krper AlphaFeldes zurck
		// -- Schlieen Hintergrund -- 
		__declspec( dllexport ) int getSBgFarbe() const; // gibt die Schlie Hintergrund Farbe zurck
		// -- Schlieen Hintergrund Bild -- 
		__declspec( dllexport ) Bild *getSBgBild() const; // gibt das Schlie Hintergrund Bild zurck
		__declspec( dllexport ) Bild *zSBgBild() const;
		// -- Schlieen AlphaFeld -- 
		__declspec( dllexport ) AlphaFeld *getSAlphaFeld() const; // gibt das Schlie AlphaFeld zurck
		__declspec( dllexport ) AlphaFeld *zSAlphaFeld() const;
		__declspec( dllexport ) int getSAfFarbe() const; // gibt die Farbe des Schlie AlphaFeldes zurck
		__declspec( dllexport ) int getSAfStrke() const; // gibt die Strke des Schlie AlphaFeldes zurck
		// -- Schlieen Klick AlphaFeld -- 
		__declspec( dllexport ) AlphaFeld *getSKAlphaFeld() const; // gibt das Schlie Klick AlphaFeld zurck
		__declspec( dllexport ) AlphaFeld *zSKAlphaFeld() const;
		__declspec( dllexport ) int getSKAfFarbe() const; // gibt die Farbe des Schlie Klick AlphaFeldes zurck
		__declspec( dllexport ) int getSKAfStrke() const; // gibt die Strke des Schlie Klick AlphaFeldes zurck
		// -- min max -- 
		__declspec( dllexport ) const Punkt &getMin() const; // gibt die minimale Fenstergre zurck
		__declspec( dllexport ) const Punkt &getMax() const; // gibt die maximale Fenstergre zurck
		__declspec( dllexport ) const Punkt &getKMin() const; // gibt die minimale Fenstergre zurck
		__declspec( dllexport ) const Punkt &getKMax() const; // gibt die maximale Fenstergre zurck
		// -- scroll -- 
		__declspec( dllexport ) VScrollBar *getVScrollBar() const; // gibt die Vertikale Scroll Bar zurck
		__declspec( dllexport ) VScrollBar *zVScrollBar() const;
		__declspec( dllexport ) HScrollBar *getHScrollBar() const; // gibt die Horizontale Scroll Bar zurck
		__declspec( dllexport ) HScrollBar *zHScrollBar() const;
		// -- Members -- 
		__declspec( dllexport ) ZeichnungArray *getMembers() const; // gibt die Members zurck
		// -- Kopie --
		__declspec( dllexport ) Zeichnung *dublizieren() const override; // Erzeugt eine Kopie des Fensters
		// Reference Counting 
		__declspec( dllexport ) Fenster *getThis();
		__declspec( dllexport ) Fenster *release();
	};
}
#endif