#pragma once

#include "Array.h"

namespace Framework
{
    class Model3DData; // Model3D.h
    class Text; // Text.h
    class Model3D; // Model3D.h

    namespace Standart3DTypes
    {
        const static char *wrfel = "f_wrfel";
    };

    // Verwaltet alle geladenen Modeldaten, so dass mehrere Zeichnungen die selben Daten benutzen knnen
    class Model3DList
    {
    private:
        static int id;
        static CRITICAL_SECTION cs;
        RCArray< Model3DData > *models;
        RCArray< Text > *names;
        int ref;

    public:
        // Konstruktor
        Model3DList();
        // Destruktor
        ~Model3DList();
        // Fgt der Liste ein Model Hinzu
        //  mdl: Das Model
        //  name: Der name, unter dem das Model in der Liste gespeichert wird
        bool addModel( Model3DData *mdl, const char *name );
        // Entfernt ein Model aus der Liste
        //  name: Der Name des Models
        void lscheModel( const char *name );
        // berprft, ob unter einem bestimmten Namen ein Model abgespeichert wurde
        //  name: Der Name
        //  return: true, wenn ein Model mit dem Namen existiert
        bool hatModel( const char *name ) const;
        // Gibt ein bestimmtes Model zurck
        //  name: Der Name des Models
        Model3DData *getModel( const char *name ) const;
        // Gibt ein bestimmtes Model ohne erhhten Reference Counter zurck
        //  name: Der Name des Models
        Model3DData *zModel( const char *name ) const;
        // Erhht den Reference Counting Zhler.
        //  return: this.
        Model3DList *getThis();
        // Verringert den Reference Counting Zhler. Wenn der Zhler 0 erreicht, wird das Zeichnung automatisch gelscht.
        //  return: 0.
        Model3DList *release();
        // Initialisiert statische private member. Wird vom Framework automatisch aufgerufen.
        static void init();
        // Lscht statische private member. Wird vom Framework automatisch aufgerufen.
        static void destroy();
    };
}